// ColorApp.cpp : Defines the entry point for the console application.
//

#include "color_wrap.cxx"
#include "color.h"

int main() {
	cmlabs::Color* color = new cmlabs::Color(10,10,10);
	color->printMe();

	PyObject *pModule, *pFunc;
	if (!Py_IsInitialized())
		Py_Initialize();

	int ret = PyRun_SimpleString("import sys");
	if (ret != 0) {
		printf("Error running commands in Python\n");
		return -1;
	}

	ret = PyRun_SimpleString("sys.path.append(\"d:\\swig\")");
	if (ret != 0) {
		printf("Error setting path in Python\n");
		return -1;
	}

	pModule = PyImport_ImportModule("colorapp");
	if (pModule == NULL) {
		printf("Couldn't load python script file colorapp.py in script path d:\\swig");
		return -1;
	}

	if (pModule != NULL) {
		pFunc = PyObject_GetAttrString(pModule, "ColorTest");
		/* pFunc is a new reference */

		if (pFunc && PyCallable_Check(pFunc)) {

			PyObject *argobj = SWIG_NewPointerObj((void*)color, SWIGTYPE_p_cmlabs__Color, 0);
			try {
				PyObject *arglist = Py_BuildValue("(O)", argobj);   // Build argument list
				PyObject_CallObject(pFunc, arglist);     // Call Python
				if (PyErr_Occurred())
				{
					PyErr_Print();
					PyErr_Clear();
				}
				Py_DECREF(arglist);
			}
			catch (...) {
				printf("Exception running function\n");
			}
			Py_DECREF(argobj);
		}
		Py_DECREF(pFunc);
		Py_DECREF(pModule);
	}

	Py_Finalize();

	return 0;
}

